From 12ef3a940f0c7d4abf3129011440684f18686951 Mon Sep 17 00:00:00 2001
From: Dmitry Logvinenko <dmlogv@gmail.com>
Date: Thu, 15 Jun 2023 19:47:51 +0300
Subject: [PATCH] lisp/org-habit.el: Inherit habit style property

* lisp/org-habit.el (org-is-habit-p):  Use `org-entry-get' with
'selective option to optionally find habit subheadings.
* etc/ORG-NEWS: Describe a breaking change.
---
 etc/ORG-NEWS      | 12 ++++++++++++
 lisp/org-habit.el |  2 +-
 2 files changed, 13 insertions(+), 1 deletion(-)

diff --git a/etc/ORG-NEWS b/etc/ORG-NEWS
index 7e7015064..ad7436c33 100644
--- a/etc/ORG-NEWS
+++ b/etc/ORG-NEWS
@@ -478,6 +478,18 @@ After:
 : ("simple" "list")
 #+end_src
 
+
+*** =org-habit.el= now optionally inherits ~:STYLE: habit~ properties
+
+Currently, the ~STYLE~ property of habits is not inherited when searching
+for entries.
+
+This change allows the property to be inherited optionally by customizing
+the ~org-use-property-inheritance~ variable.
+
+This change aims to provide more flexibility in managing habits, allowing
+users to dedicate separate subtrees or files to habits without manually
+setting the ~STYLE~ property for each sub-task.
 ** New features
 *** Clock table can now produce quarterly reports
 
diff --git a/lisp/org-habit.el b/lisp/org-habit.el
index ea935fe7c..b7ba6e349 100644
--- a/lisp/org-habit.el
+++ b/lisp/org-habit.el
@@ -170,7 +170,7 @@ means of creating calendar-based reminders."
 
 (defun org-is-habit-p (&optional pom)
   "Is the task at POM or point a habit?"
-  (string= "habit" (org-entry-get (or pom (point)) "STYLE")))
+  (string= "habit" (org-entry-get (or pom (point)) "STYLE" 'selective)))
 
 (defun org-habit-parse-todo (&optional pom)
   "Parse the TODO surrounding point for its habit-related data.
-- 
2.40.1

